////////////////////////////////////////////////////////////////////
//
//  Tutorial uso di MySql con driver ODBC della actual technologies
//
//  Created by Francesco Germinara 
// 
//  Freeware (c) 2005 SofTech di F.Germinara - www.germinara.it. 
//
//  For information please contact me at info@germinara.it 
////////////////////////////////////////////////////////////////////
//  History:
//
//  Description:
//
////////////////////////////////////////////////////////////////////

#import "panelMovimentiController.h"
#import "NSString+FGString.h" //Expand NSString class using Categories
#import "FGBseData.h"         //manage Data field

@implementation panelMovimentiController

- (void) dealloc {
	[dsMovimenti release];
	[cmbRicorrenzeDS release];

	[super dealloc];
}

-(void) awakeFromNib{
  dsMovimenti=[[FGODBCResultSet alloc] init:theApp SetIdentifier:@"STORICOREGALI" tableView:elencoMovimenti];
  
  [self setCtrlStat:TRUE]; //enable/disable control in user interface
  
  [elencoMovimenti setTarget:self];
  [elencoMovimenti setDoubleAction:@selector(loadSelectedData)]; //Double click
  
  cmbRicorrenzeDS=[[cmbRicorrenzeDataSource alloc] init];
  
 FGBseData *aDate=[[FGBseData alloc] init];
 [aDate Oggi];
 [anno setStringValue:[aDate AA]];
 [aDate release];
}

-(void) startUseDataSourceForComboBox{
 //Set datasource to ComboBox
  NSString *strQuery;
  [idTipoRicorrenza setDataSource:nil]; 
   strQuery=[NSString stringWithString:@"order by DESCR"];
  [cmbRicorrenzeDS FillArray:theApp->pTabRicorrenze SqlFilter:strQuery strKey:@"ID_TIPO_RICOR" strItem:@"DESCR"];
  [idTipoRicorrenza setDataSource:cmbRicorrenzeDS];
  [idTipoRicorrenza selectItemAtIndex:0];
}


-(void) startUseDataSource{
 [elencoMovimenti setDataSource:nil];
   //Execute the query for dataset result 
 [dsMovimenti FillArray:theApp->pTabStoricoRegali SqlFilter:@"order by ANNO,ID_PERSONA,ID_TIPO_RICOR" ProgressInd:nil]; 
 //Set datasource to tableview
 [elencoMovimenti setDataSource:dsMovimenti];
 }

- (IBAction)btnBarraAzionePremuto:(id)sender
{
 //Chiudo la finestra
 int nOperationToDo=0;
 nOperationToDo=[sender selectedSegment]; //Get the Button That is selected on the segment
 id aPanel=[sender window];
 
  if(nOperationToDo == 0){ //REGISTRA was pressed Insert/Modify the record
   [self updateRecord];
  
   [self startUseDataSource];    //refresh datasource 
   
   [self setCtrlStat:FALSE];
   [self clearFelds];
  }
  
 if(nOperationToDo == 1){ //CANCELLA was pressed Delete the record
	NSString *strInfo;
	strInfo=[NSString stringWithFormat:@"Do you want delete %@.  Are you sure ?",[[idPersona stringValue]TrimRight]];
	int rc=NSRunAlertPanel(@"Warning!",strInfo,@"YES",@"NO",nil);
	if(rc==NSOKButton){	
     [self deleteRecord];
  
    [self startUseDataSource];    //refresh datasource 
	
	[self setCtrlStat:TRUE];
	[self clearFelds];
   }
  }

 if(nOperationToDo == 2){ //ELIMINA TUTTI was pressed Delete all records
  NSString *strInfo;
  strInfo=[NSString stringWithString:@"Do you want remove all records. Are you sure ?"];
  int rc=NSRunAlertPanel(@"Warning!",strInfo,@"YES",@"NO",nil);
  if(rc==NSOKButton){	
   [self deleteAllRecords];
  
   [self startUseDataSource];    //refresh datasource 
   
   [self setCtrlStat:TRUE];
   [self clearFelds];
   }
  }
  
  if(nOperationToDo == 3){ //STAMPA was pressed Print all records
   [elencoMovimenti print:self];
  }
 

 if(nOperationToDo == 4){      //AIUTAMI was pressed show search panel  
    [NSApp beginSheet:panelCerca modalForWindow:[NSApp mainWindow] modalDelegate:self didEndSelector:@selector(sheetDidEnd: returnCode: contextInfo:) contextInfo:NULL];
 }
 
}




- (NSMutableString *)controlloDati:(BOOL *) bStdOK newRecord:(BOOL *)bNuovoRecord
{
(*bStdOK)=TRUE;

//1: Check if key field is valid
NSString *aStringPersona=[[idPersona stringValue] TrimRight]; //Eliminate right blanks

if([aStringPersona isEqualToString:@""]){
 NSRunAlertPanel(@"ERROR",@"You must specify a valid id for a person!",@"OK",nil,nil);
 (*bStdOK)=FALSE;
}

if([aStringPersona length] >25){
 NSRunAlertPanel(@"ERROR",@"Lenght must not exceed 25 character!",@"OK",nil,nil);
 (*bStdOK)=FALSE;
}

NSString *aStringRegalo=[[idRegalo stringValue] TrimRight];
if([aStringRegalo isEqualToString:@""]){
 NSRunAlertPanel(@"ERROR",@"You must specify a valid id for the gift!",@"OK",nil,nil);
 (*bStdOK)=FALSE;
}

if([aStringRegalo length] >25){
 NSRunAlertPanel(@"ERROR",@"Lenght must not exceed 25 character!",@"OK",nil,nil);
 (*bStdOK)=FALSE;
}


NSString *aStringTipoRicor=[cmbRicorrenzeDS GetkeyAtRow:[idTipoRicorrenza indexOfSelectedItem]];

int nAnno=[[anno stringValue] intValue];
if(nAnno==0){
 NSRunAlertPanel(@"ERROR",@"You must specify the year!",@"OK",nil,nil);
 (*bStdOK)=FALSE;
}

NSMutableString *strQuery;
strQuery=[[NSMutableString alloc] initWithFormat:@"WHERE ID_PERSONA='%@' AND ID_REGALO='%@' AND CAST(ANNO AS UNSIGNED INT)=%d and ID_TIPO_RICOR='%@'",aStringPersona,aStringRegalo,nAnno,aStringTipoRicor ]; //Build the query 

if( (*bStdOK)==TRUE){
 if([theApp->pTabStoricoRegali LoadDati:strQuery] == TRUE){
  NSLog(@"Found: %@ in table STORICOREGALI",strQuery);
  (*bNuovoRecord)=TRUE;
 }else{
  NSLog(@"Not Found: %@ in table STORICOREGALI",strQuery);
  (*bNuovoRecord)=FALSE; 
 }
}
return strQuery;
}

//Update Record
-(void)updateRecord{
NSMutableString *strQuery;
BOOL sts=FALSE;
BOOL bCanUpdate=FALSE;
strQuery=[self controlloDati:&bCanUpdate newRecord:&sts];
if(!bCanUpdate){
 [strQuery release];
 return;
} 

//Assign new data value for the record	
[[theApp->pTabStoricoRegali FieldInfo:@"ID_PERSONA"] SetValue:[idPersona stringValue]];	
[[theApp->pTabStoricoRegali FieldInfo:@"ID_REGALO"] SetValue:[idRegalo stringValue]];	
[[theApp->pTabStoricoRegali FieldInfo:@"ANNO"] SetValue:[anno stringValue]]; 
NSString *aStringTipoRicor=[cmbRicorrenzeDS GetkeyAtRow:[idTipoRicorrenza indexOfSelectedItem]];
[[theApp->pTabStoricoRegali FieldInfo:@"ID_TIPO_RICOR"] SetValue:aStringTipoRicor];
 	
 //If not exist make a INSERT else a UPDATE	
 if(sts==FALSE)
  [theApp->pTabStoricoRegali Insert];
 else
  [theApp->pTabStoricoRegali Update:strQuery];
  
 [strQuery release];
}

//Delete Record
-(void)deleteRecord{
NSMutableString *strQuery;
BOOL sts=FALSE;
BOOL bCanUpdate=FALSE;
strQuery=[self controlloDati:&bCanUpdate newRecord:&sts];
if(!bCanUpdate){
 [strQuery release];
 return;
} 

[theApp->pTabStoricoRegali Delete:strQuery]; 
[strQuery release];

}

//Delete all records
-(void)deleteAllRecords{
 [theApp->pTabStoricoRegali Delete:@""]; 
}

//enable/disable control in user interface
-(void)setCtrlStat:(BOOL) bSts{ 
// [pulsantiAzione setEnabled:!bSts forSegment:0]; //Enable/Disable REGISTRA
// [pulsantiAzione setEnabled:!bSts forSegment:1]; //Enable/Disable CANCELLA
}

//Double click action
-(void)loadSelectedData{
 int nSelectedRow=[elencoMovimenti clickedRow];
 FGODBCRecord *tmpRecord=[dsMovimenti GetSingleRow:nSelectedRow];

 //Update info in user interface
 [idPersona setStringValue:[[tmpRecord FieldInfo:@"ID_PERSONA"] GetValue]];
 [idRegalo setStringValue:[[tmpRecord FieldInfo:@"ID_REGALO"] GetValue]];
 [anno setStringValue:[[tmpRecord FieldInfo:@"ANNO"] GetValue]];
 NSString *aTipoRicorrenzaCode=[[tmpRecord FieldInfo:@"ID_TIPO_RICOR"] GetValue];
 int nIndex=[cmbRicorrenzeDS searchForKey:aTipoRicorrenzaCode];
 [idTipoRicorrenza selectItemAtIndex:nIndex];
 
 
    NSMutableString *strQuery;
    strQuery=[NSMutableString stringWithFormat:@"WHERE ID_PERSONA='%@' ",[idPersona stringValue]]; //Build the query 
    if([theApp->pTabPersone LoadDati:strQuery] == TRUE)
     [descPersona setStringValue:[NSString stringWithFormat:@"%@",[[[theApp->pTabPersone FieldInfo:@"DESCR"] GetValue] TrimRight] ]]; 
    else
     [descPersona setStringValue:@"Persona insesistente!"];  
	 
    strQuery=[NSMutableString stringWithFormat:@"WHERE ID_REGALO='%@' ",[idRegalo stringValue]]; //Build the query 
    if([theApp->pTabRegali LoadDati:strQuery] == TRUE)
     [descrRegalo setStringValue:[NSString stringWithFormat:@"%@",[[[theApp->pTabRegali FieldInfo:@"DESCR"] GetValue] TrimRight] ]]; 
    else
     [descrRegalo setStringValue:@"Regalo insesistente!"]; 
	 

 [self setCtrlStat:FALSE];
}

//Clear user input fields data
-(void)clearFelds{
 [idPersona setStringValue:@""];
 [idRegalo setStringValue:@""];
 [descPersona setStringValue:@""];
 [descrRegalo setStringValue:@""];

 [idTipoRicorrenza selectItemAtIndex:0];
}

//Conrtollo le descrizioni, quando cambia il focus sui campi Persona e Regalo
- (void)controlTextDidEndEditing:(NSNotification *)aNotification{
  NSMutableString *strQuery;
  if([aNotification object] == idPersona){
    strQuery=[NSMutableString stringWithFormat:@"WHERE ID_PERSONA='%@' ",[idPersona stringValue]]; //Build the query 
    if([theApp->pTabPersone LoadDati:strQuery] == TRUE)
     [descPersona setStringValue:[NSString stringWithFormat:@"%@",[[[theApp->pTabPersone FieldInfo:@"DESCR"] GetValue] TrimRight] ]]; 
    else
     [descPersona setStringValue:@"Person does't exist!"]; 
 }
 
  if([aNotification object] == idRegalo){
    strQuery=[NSMutableString stringWithFormat:@"WHERE ID_REGALO='%@' ",[idRegalo stringValue]]; //Build the query 
    if([theApp->pTabRegali LoadDati:strQuery] == TRUE)
     [descrRegalo setStringValue:[NSString stringWithFormat:@"%@",[[[theApp->pTabRegali FieldInfo:@"DESCR"] GetValue] TrimRight] ]]; 
    else
     [descrRegalo setStringValue:@"Gift does't exit!"]; 
 }
  
}

-(void) updateDescription{
    NSMutableString *strQuery;
    strQuery=[NSMutableString stringWithFormat:@"WHERE ID_PERSONA='%@' ",[idPersona stringValue]]; //Build the query 
    if([theApp->pTabPersone LoadDati:strQuery] == TRUE)
     [descPersona setStringValue:[NSString stringWithFormat:@"%@",[[[theApp->pTabPersone FieldInfo:@"DESCR"] GetValue] TrimRight] ]]; 
    else
     [descPersona setStringValue:@""];  
	 
    strQuery=[NSMutableString stringWithFormat:@"WHERE ID_REGALO='%@' ",[idRegalo stringValue]]; //Build the query 
    if([theApp->pTabRegali LoadDati:strQuery] == TRUE)
     [descrRegalo setStringValue:[NSString stringWithFormat:@"%@",[[[theApp->pTabRegali FieldInfo:@"DESCR"] GetValue] TrimRight] ]]; 
    else
     [descrRegalo setStringValue:@""]; 
}

@end
